package com.maroontress.madangler.client;

import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.Response;
import com.google.gwt.user.client.ui.CheckBox;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Hyperlink;
import com.google.gwt.user.client.ui.ScrollPanel;
import com.google.gwt.user.client.ui.SourcesTabEvents;
import com.google.gwt.user.client.ui.TabBar;
import com.google.gwt.user.client.ui.TabListener;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.xml.client.DOMException;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.NodeList;
import com.maroontress.madangler.client.request.Parameters;
import com.maroontress.madangler.client.request.RequestKit;
import com.maroontress.madangler.client.request.RequestListener;
import java.util.ArrayList;

/**
   ӥɾܺ٤ɽѥͥǤ
*/
public class BuildDetailPanel extends VerticalPanel {

    /** LogProperty */
    private ArrayList codeTable;

    /** ǽʬɽ뤫ɤΥåܥå */
    private CheckBox showsTail;

    /** إåΥѥͥ */
    private DockPanel dp;

    /**  */
    private HTML author;

    /**  */
    private HTML date;

    /** ӥɾܺ٤ɽǤʤȤΥҥ */
    private HTML hint;

    /** κǸ򼨤ޡ */
    private HTML logTail;

    /** Υƥ */
    private HTML logText;

    /** ӥɷ̡OK/NG */
    private HTML result;

    /** ӥ */
    private HTML revision;

    /** ӥɥɽ뤿Υϥѡ */
    private Hyperlink getOut;

    /** ӥɥɽ */
    private Link externalLink;

    /** ӥɾꥯȥå */
    private RequestKit kit;

    /** ӥɥꥯȥå */
    private RequestKit logKit;

    /** ӥɾΥꥯȥꥹ */
    private RequestListener loadedListener;

    /** ӥɥΥꥯȥꥹ */
    private RequestListener logLoadedListener;

    /** ɽ륹ѥͥ */
    private ScrollPanel sp;

    /** ץȤID */
    private String id;

    /** ӥɤΥꥢ */
    private String serial;

    /** ץåȥեΥ */
    private TabBar bar;

    /** ǽɽץåȥեΥǥå */
    private int defaultPlatformCode;

    /**
       ӥɾܺ٥ѥͥޤ
    */
    public BuildDetailPanel() {
	externalLink = new Link("buildLog");

        codeTable = new ArrayList();
	id = null;
	serial = null;
	String stylePrefix = "buildDetailPanel-";

	hint = new HTML();
	add(hint);

	VerticalPanel westPanel = new VerticalPanel();
	date = new HTML();
	westPanel.add(date);
	revision = new HTML();
	westPanel.add(revision);
	author = new HTML();
	westPanel.add(author);
	result = new HTML();
	westPanel.add(result);

	showsTail = new CheckBox("Display only the last part");
	showsTail.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		String s = (showsTail.isChecked()) ? "yes" : "no";
		externalLink.addParameter("tail", s);
		externalLinkUpdated();
		int selectedTab = bar.getSelectedTab();
		LogProperty prop = (LogProperty) codeTable.get(selectedTab);
		getLog(prop.getPlatformCode());
	    }
	});

	getOut = new Hyperlink();
	getOut.setHTML("<img src=\"images/getout.png\" border=\"0\">");
	getOut.setTitle("Show in another window");

	dp = new DockPanel();
	dp.add(westPanel, DockPanel.WEST);
	dp.add(showsTail, DockPanel.CENTER);
	dp.add(getOut, DockPanel.EAST);
	dp.setCellHorizontalAlignment(westPanel, ALIGN_LEFT);
	dp.setCellHorizontalAlignment(getOut, ALIGN_RIGHT);
	dp.setWidth("100%");
	add(dp);
	add(new HTML("&nbsp;"));

	bar = new TabBar();
	bar.setStyleName(stylePrefix + "TabBar");
	bar.addTabListener(new TabListener() {
	    public boolean onBeforeTabSelected(final SourcesTabEvents sender,
					       final int tabIndex) {
		int selecedTab = bar.getSelectedTab();
		if (selecedTab == -1) {
		    return true;
		}
		LogProperty prop = (LogProperty) codeTable.get(selecedTab);
		prop.setScrollPosition(sp.getScrollPosition());
		return true;
	    }
	    public void onTabSelected(final SourcesTabEvents sender,
				      final int tabIndex) {
		externalLink.addParameter("platformCode", "" + tabIndex);
		externalLinkUpdated();
		LogProperty prop = (LogProperty) codeTable.get(tabIndex);
		getLog(prop.getPlatformCode());
	    }
	});
	add(bar);

	logText = new HTML();
	logText.setStyleName("logText");
	logTail = new HTML("~");
	logTail.setStyleName("logText");
	VerticalPanel vp = new VerticalPanel();
	vp.add(logText);
	vp.add(logTail);
 	sp = new ScrollPanel();
	sp.setAlwaysShowScrollBars(true);
	sp.setWidget(vp);
	sp.setStyleName("logTextPanel");
	sp.setSize("100%", "100%");
	add(sp);

	kit = new RequestKit();
        loadedListener = new RequestListener() {
	    public void startRequest() {
		startLoading();
	    }
	    public void stopRequest() {
		stopLoading();
	    }
	    public void responseReceived(final Request req,
					 final Response res) {
		int tabs = parseGetBuildDetailResponse(res.getText());
		if (tabs < 0) {
		    clearDetail();
		} else if (tabs == 0) {
		    showDetailUnknown();
		} else {
		    showDetail();
		}
	    }
	    public void errorThrown(final Request req,
				    final Throwable e) {
		MadAngler.alert(e.getMessage());
		clearDetail();
	    }
	};
	logKit = new RequestKit();
        logLoadedListener = new RequestListener() {
	    public void startRequest() {
		MadAngler.setLoading(true);
		showsTail.setEnabled(false);
	    }
	    public void stopRequest() {
		MadAngler.setLoading(false);
		showsTail.setEnabled(true);
	    }
	    public void responseReceived(final Request req,
					 final Response res) {
		logText.setHTML(res.getText());
		int selectedTab = bar.getSelectedTab();
		LogProperty prop = (LogProperty) codeTable.get(selectedTab);
		int pos = prop.getScrollPosition();
		if (pos == -1) {
		    sp.ensureVisible(logTail);
		} else {
		    sp.setScrollPosition(prop.getScrollPosition());
		}
	    }
	    public void errorThrown(final Request req,
				    final Throwable e) {
		MadAngler.alert(e.getMessage());
	    }
	};

        setCellHeight(sp, "100%");
        setCellWidth(sp, "100%");
	setSize("100%", "100%");
    }

    /**
       externalLink򹹿̤ϥѡ󥯤ȿǤޤ
    */
    private void externalLinkUpdated() {
        getOut.setTargetHistoryToken(externalLink.encode());
    }

    /**
       ̿ξ֤ꤷޤ
    */
    private void startLoading() {
        MadAngler.setLoading(true);
	hint.setHTML("Loading...");
	hint.setVisible(true);
	setDetailVisible(false);
    }

    /**
       ̿ξ֤ꤷޤ
    */
    private void stopLoading() {
        MadAngler.setLoading(false);
    }

    /**
       ܺ٤βĻ롢ԲĻꤷޤ

       @param b trueϲĻ롢falseԲĻ
    */
    private void setDetailVisible(final boolean b) {
	dp.setVisible(b);
	bar.setVisible(b);
	sp.setVisible(b);
	if (b) {
	    MadAngler.resize();
	}
    }

    /**
       ӥɥñȤɽϥѡ󥯤βĻ롢ԲĻꤷޤ

       ɥ⡼ɤǤϥϥѡ󥯤ɽޤ󡣥ӥȥ
       ⡼ɤǤϥϥѡ󥯤ɽޤ

       @param b trueϥɥ⡼ɡfalseϥӥȥ⡼
    */
    public void setStandalone(final boolean b) {
	getOut.setVisible(!b);
    }

    /**
       ξܺ٤ɽޤ

       ҥȤϱޤ
    */
    private void showDetail() {
	hint.setVisible(false);
	setDetailVisible(true);
    }

    /**
       򤵤ƤʤΥҥȤɽޤ

       ξܺ٤ϱޤ
    */
    private void clearDetail() {
	hint.setHTML("Click the row above to show the detail.");
	hint.setVisible(true);
	setDetailVisible(false);
    }

    /**
       ξܺ٤ѤǤʤΥҥȤɽޤ

       ξܺ٤ϱޤ

       줬ɽ򤵤줿ӥɤΥץåȥեब1Ĥ
       ӥɤƤʤӥɤ򥹥åפ줿Τɤ餫ˤʤ
       ޤ
    */
    private void showDetailUnknown() {
	hint.setHTML("The log is currently not available, "
		     + "otherwise the build has been skipped.");
	hint.setVisible(true);
	setDetailVisible(false);
    }

    /**
       getBuildDetail쥹ݥ󥹤ѡޤ

       @param text getBuildDetail쥹ݥ
       @return 0Ǥʤ-1
    */
    private int parseGetBuildDetailResponse(final String text) {
	Status status;
        try {
	    status = new Status(text);
        } catch (DOMException e) {
            MadAngler.alert(e.getMessage());
            return -1;
        }
	if (status.getCode() != 0) {
            MadAngler.alert(status.getMessage());
            return -1;
	}
	Element d = status.getFirstChildNode("detail");
	if (d == null) {
            MadAngler.alert("response has no detail element.");
            return -1;
	}
	date.setText("Date: " + d.getAttribute("date"));
	revision.setText("Revision: " + d.getAttribute("revision"));
	author.setText("Author: " + d.getAttribute("author"));
	result.setHTML("Result: "
		       + BuildResult.getResultHTML(d.getAttribute("status")));
	while (bar.getTabCount() > 0) {
	    bar.removeTab(0);
	}
	codeTable.clear();
        NodeList nl = status.getChildNodes("platform");
	for (int k = 0; k < nl.getLength(); ++k) {
	    Element p = (Element) nl.item(k);
	    bar.addTab(p.getAttribute("id") + ": "
		       + BuildResult.getResultHTML(p.getAttribute("status")),
		       true);
	    codeTable.add(new LogProperty(p.getAttribute("code")));
        }
	int tabCount = bar.getTabCount();
	if (tabCount > 0) {
	    bar.selectTab((defaultPlatformCode < tabCount)
			  ? defaultPlatformCode : 0);
	}
	return tabCount;
    }

    /**
       getBuildLogꥯȤǥΥƥȤޤ

       @param platformCode ץåȥեॳ
    */
    private void getLog(final String platformCode) {
	Parameters params = new Parameters();
	params.add("method", "getBuildLog");
	params.add("projectId", id);
	params.add("serial", serial);
	params.add("platformCode", platformCode);
	if (showsTail.isChecked()) {
	    params.add("tail", "yes");
	}
	logKit.sendRequest(params.toString(), logLoadedListener);
    }

    /**
       ѥͥΥꤷޤ

       @param width 
       @param height ⤵
    */
    public void adjustSize(int width, int height) {
	width -= 2 * sp.getAbsoluteLeft();
	if (width < 1) {
	    width = 1;
	}
	height -= sp.getAbsoluteTop() + 4;
	if (height < 1) {
	    height = 1;
	}
	sp.setPixelSize(width, height);
    }

    /**
       ʥӥ󥯤ꤷޤ

       󥯤id, serial, platformCode, tailΥѥ᡼򥤥󥹥
       ꤷ塢ϥѡ󥯤򹹿getBuildDetailꥯ
       Ȥǥӥɤξܺ٤ޤ

       @param link 
    */
    public void setLink(final Link link) {
	id = link.getParameter("id");

	serial = link.getParameter("serial");
	if (serial == null) {
	    clearDetail();
	    return;
	}

	String platformCode = link.getParameter("platformCode");
	if (platformCode == null) {
	    defaultPlatformCode = 0;
	} else {
	    defaultPlatformCode = Integer.parseInt(platformCode);
	}

	String tail = link.getParameter("tail");
	if (tail == null) {
	    tail = "yes";
	}
	showsTail.setChecked(tail.equals("yes") || tail.equals("true"));

	externalLink.addParameter("id", id);
	externalLink.addParameter("serial", serial);
	externalLink.addParameter("platformCode", platformCode);
	externalLink.addParameter("tail", tail);
	externalLinkUpdated();

	Parameters params = new Parameters();
	params.add("method", "getBuildDetail");
	params.add("projectId", id);
	params.add("serial", serial);
	kit.sendRequest(params.toString(), loadedListener);
    }
}
