package com.maroontress.madangler.client;

import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.Response;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.SourcesTableEvents;
import com.google.gwt.user.client.ui.TableListener;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.xml.client.DOMException;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.NodeList;
import com.maroontress.madangler.client.request.Parameters;
import com.maroontress.madangler.client.request.RequestKit;
import com.maroontress.madangler.client.request.RequestListener;
import java.util.ArrayList;

/**
   ӥɰѥͥǤ
*/
public class BuildListPanel extends SubPanel {

    /** ӥɤΥꥢ */
    private ArrayList serialTable;

    /** ӥɾܺ٤ɽѥͥ */
    private BuildDetailPanel detailPanel;

    /** ӥɰɽեåơ֥ */
    private FlexTable table;

    /** ӥɤɽǤʤȤɽҥ */
    private HTML html;

    /** ΥڡΥ */
    private HTML next;

    /** ΥڡΥ */
    private HTML prev;

    /** ڡڤؤΥ󥯤֤ѥͥ */
    private HorizontalPanel pager;

    /** ɤ߹ߥܥ */
    private Image reload;

    /** ʥӥ */
    private Navigation navi;

    /** ץȥȥѥͥ */
    private ProjectTitlePanel projectTitle;

    /** ꥯȥå */
    private RequestKit kit;

    /** ꥯȥꥹ */
    private RequestListener loadedListener;

    /** ץȤID */
    private String id;

    /** ڡγϥꥢ */
    private String nextSerialStart;

    /** ڡγϥꥢ */
    private String prevSerialStart;

    /** 򤵤Ƥ륷ꥢ */
    private String selectedSerial;

    /**
       ӥɰѥͥޤ
    */
    public BuildListPanel() {
	navi = new Navigation("Builds");
	navi.setLink(new Link("buildList"));

        serialTable = new ArrayList();
        prevSerialStart = null;
        nextSerialStart = null;
	id = null;
	selectedSerial = null;

	projectTitle = new ProjectTitlePanel();
	add(projectTitle);
	add(new HTML("&nbsp;"));

        reload = new Image("images/reload.png");
	reload.setStyleName("imageButton");
	reload.setTitle("Reload");
        reload.addClickListener(new ClickListener() {
            public void onClick(final Widget sender) {
		updateBuildsList(null);
            }
        });
        add(reload);
	add(new HTML("&nbsp;"));

        table = new FlexTable();
        table.setWidth("100%");
	table.setCellSpacing(0);
	// table.setCellPadding(0);
        table.setVisible(false);
	table.addTableListener(new TableListener() {
            public void onCellClicked(final SourcesTableEvents ev,
                                      final int row, final int cell) {
                if (row == 0) {
                    return;
                }
		selectedSerial = (String) serialTable.get(row - 1);
		navi.getLink().addParameter("serial", selectedSerial);
		updateSerialSelection();
                detailPanel.setLink(navi.getLink());
            }
	});
        add(table);

        html = new HTML();
        add(html);

        prev = new HTML("<b title=\"Previous page\">&lt;&lt;</b>");
        prev.setStyleName("ma-Pager");
        prev.addClickListener(new ClickListener() {
            public void onClick(final Widget sender) {
                updateBuildsList(prevSerialStart);
            }
        });

        next = new HTML("<b title=\"Next page\">&gt;&gt;</b>");
        next.setStyleName("ma-Pager");
        next.addClickListener(new ClickListener() {
            public void onClick(final Widget sender) {
                updateBuildsList(nextSerialStart);
            }
        });

        pager = new HorizontalPanel();
        HTML vsep = new HTML("&nbsp;|&nbsp;");
        pager.setHorizontalAlignment(HorizontalPanel.ALIGN_CENTER);
        pager.add(new HTML("&nbsp;"));
        pager.add(prev);
        pager.add(vsep);
        pager.add(next);
        pager.add(new HTML("&nbsp;"));
        pager.setCellWidth(prev, "1%");
        pager.setCellWidth(vsep, "1%");
        pager.setCellWidth(next, "1%");
        pager.setWidth("100%");
        add(pager);
	add(new HTML("<hr>"));

	detailPanel = new BuildDetailPanel();
	add(detailPanel);

	kit = new RequestKit();
        loadedListener = new RequestListener() {
	    public void startRequest() {
		setLoading(true);
	    }
	    public void stopRequest() {
		setLoading(false);
	    }
	    public void responseReceived(final Request req,
					 final Response res) {
		if (parseListBuildsResponse(res.getText()) < 0) {
		    notifyCanceled();
		    return;
		}
		updateInteraction();
	    }
	    public void errorThrown(final Request req,
				    final Throwable e) {
		MadAngler.alert(e.getMessage());
		notifyCanceled();
	    }
	};

        setWidth("100%");
        setHeight("100%");
        setCellHeight(detailPanel, "100%");
    }

    /**
       ֤̿ꤷޤ

       @param b true̿桢false̿
    */
    private void setLoading(final boolean b) {
        MadAngler.setLoading(b);
        reload.setVisible(!b);
        table.setVisible(!b);
	html.setVisible(!b);
        pager.setVisible(!b);
	detailPanel.setVisible(!b);
    }

    /**
       ǽĻĴޤ
    */
    private void updateInteraction() {
        if (serialTable.size() == 0) {
	    table.setVisible(false);
            html.setHTML("<b>No builds found.</b>");
	    html.setVisible(true);
	    pager.setVisible(false);
	    detailPanel.setVisible(false);
	    return;
	}
	table.setVisible(true);
	html.setVisible(false);
	detailPanel.setVisible(true);
	if (prevSerialStart == null && nextSerialStart == null) {
	    pager.setVisible(false);
	} else {
	    pager.setVisible(true);
	    prev.setVisible(prevSerialStart != null);
	    next.setVisible(nextSerialStart != null);
	}
	MadAngler.resize();
    }

    /**
       ӥɰ򥯥ꥢơ٥ӥɰޤ

       @param startKey ϥꥢ
    */
    private void updateBuildsList(final String startKey) {
        int n = table.getRowCount();
        for (int k = 0; k < n; ++k) {
            table.removeRow(0);
        }
        serialTable.clear();
	prevSerialStart = null;
	nextSerialStart = null;
	navi.getLink().addParameter("startKey", startKey);

	Parameters params = new Parameters();
	params.add("method", "listBuilds");
	params.add("projectId", id);
	if (startKey != null) {
	    params.add("startKey", startKey);
	}
	kit.sendRequest(params.toString(), loadedListener);
    }

    /**
       listBuilds쥹ݥ󥹤ѡޤ

       @param text listBuilds쥹ݥ
       @return 0Ǥʤ-1
    */
    private int parseListBuildsResponse(final String text) {
	Status status;
        try {
	    status = new Status(text);
        } catch (DOMException e) {
            MadAngler.alert(e.getMessage());
            return -1;
        }
	if (status.getCode() != 0) {
            MadAngler.alert(status.getMessage());
            return -1;
	}
        NodeList nl = status.getChildNodes("build");
        for (int k = 0; k < nl.getLength(); ++k) {
            Element build = (Element) nl.item(k);
            String serial = build.getAttribute("serial");
            String revision = build.getAttribute("revision");
            String author = build.getAttribute("author");
            String date = build.getAttribute("date");
            String result = build.getAttribute("status");
            addRow(serial, revision, author, date, result);
        }
	addHeader();
	updateSerialSelection();

	Element prev = status.getFirstChildNode("prev");
        prevSerialStart = ((prev == null)
			   ? null : prev.getAttribute("serial"));

	Element next = status.getFirstChildNode("next");
	nextSerialStart = ((next == null)
			   ? null : next.getAttribute("serial"));
	return 0;
    }

    /**
       եåơ֥˥ơ֥إåޤ
    */
    private void addHeader() {
	table.insertRow(0);
        table.setText(0, 0, "Date");
        table.setText(0, 1, "Revision");
        table.setText(0, 2, "Author");
        table.setText(0, 3, "Status");
	setRowFormat(0, "buildHeader");
    }

    /**
       ơ֥˹ԤɲäꥢˤǤɲäޤ

       @param serial ꥢ
       @param rev ӥ
       @param author 
       @param date 
       @param status ӥɷ̤HTMLʸ
    */
    private void addRow(final String serial, final String rev,
			final String author, final String date,
			final String status) {
	final String result;

	result = BuildResult.getResultHTML(status);
        int row = serialTable.size();
        table.setText(row, 0, date);
        table.setText(row, 1, rev);
        table.setText(row, 2, author);
        table.setHTML(row, 3, result);
        serialTable.add(serial);
    }

    /**
       եåơ֥ιԤ˥ꤷޤ

       @param row 
       @param name ̾
    */
    private void setRowFormat(final int row, final String name) {
	FlexTable.FlexCellFormatter formatter = table.getFlexCellFormatter();
	for (int k = 0; k < 4; ++k) {
	    formatter.setStyleName(row, k, name);
	}
    }

    /**
       ꥢѹ줿Ȥ˸ƤӽФޤ
    */
    private void updateSerialSelection() {
	int n = serialTable.size();
	for (int k = 0; k < n; ++k) {
	    String serial = (String) serialTable.get(k);
	    String name = ((selectedSerial.equals(serial))
			   ? "buildSelected" : "build");
	    setRowFormat(k + 1, name);
	}
    }

    /**
       ѥͥΥꤷޤ

       @param width 
       @param height ⤵
    */
    public void adjustSize(final int width, final int height) {
	detailPanel.adjustSize(width, height);
    }

    /**
       {@inheritDoc}
    */
    public Navigation getNavigation() {
	return navi;
    }

    /**
       {@inheritDoc}
    */
    public void setLink(final Link link) {
	id = link.getParameter("id");
	String startKey = link.getParameter("startKey");
	selectedSerial = link.getParameter("serial");

	projectTitle.setProjectId(id);
	updateBuildsList(startKey);
	detailPanel.setLink(link);
	navi.setLink(link);
    }
}
